// SmartIOHelper.h
#if !defined __SmartIOHelper_h__
#define __SmartIOHelper_h__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "windows.h"

// Declare library for dynamic linking to SMARTIO.DLL
// --------------------------------------------------
HINSTANCE gLibSMARTIO = NULL;

// Declare library for dynamic linking to KEYBDDR.DLL
// --------------------------------------------------
HINSTANCE gLibKEYBDDR = NULL;

// forward declarations
BOOL LoadSmartIO();

typedef UINT (*SIOFIRMWAREVERSION)(void);
typedef BYTE (*SIOREADKEYPAD)(void);
typedef BOOL (*SIOSETKEYPADSIZE)(BYTE x, BYTE y);
typedef UINT (*SIOANALOGCONVERSION)(BYTE channel);
typedef void (*SIOSELECTOPTION)(BYTE Option);
typedef void (*SIOBACKLIGHTVEEPWM)(BYTE value);
typedef void (*SIOBACKLIGHTPWM)(BYTE value);
typedef void (*SIOBACKLIGHTON)(void);
typedef void (*SIOBACKLIGHTOFF)(void);
typedef UINT (*SIOREADDEVICEVERSION)(void);
typedef UINT (*SIOREADDEVICEPARTTYPE)(void);
typedef void (*SIOWRITEPORTA)(BYTE value);
typedef void (*SIOWRITEPORTB)(BYTE value);
typedef void (*SIOWRITEPORTC)(BYTE value);
typedef void (*SIOWRITEPORTD)(BYTE value);
typedef void (*SIOINITDDRA)(BYTE value);
typedef void (*SIOINITDDRB)(BYTE value);
typedef void (*SIOINITDDRC)(BYTE value);
typedef void (*SIOINITDDRD)(BYTE value);
typedef UINT (*SIOREADPORTA)(void);
typedef UINT (*SIOREADPORTB)(void);
typedef UINT (*SIOREADPORTC)(void);
typedef UINT (*SIOREADPORTD)(void);
typedef UINT (*SIOREADEEPROM)(BYTE blockNumber, BYTE dataBytes[16]);
typedef UINT (*SIOWRITEEEPROM)(BYTE blockNumber, BYTE dataBytes[16]);


SIOFIRMWAREVERSION		SIOFirmwareVersion;
SIOREADKEYPAD			SIOReadKeypad;
SIOSETKEYPADSIZE		SIOSetKeyPadSize;
SIOANALOGCONVERSION		SIOAnalogConversion;
SIOSELECTOPTION			SIOSelectOption;
SIOBACKLIGHTVEEPWM		SIOBackLightVEEPwm;
SIOBACKLIGHTPWM			SIOBackLightPwm;
SIOBACKLIGHTON			SIOBackLightON;
SIOBACKLIGHTOFF			SIOBackLightOFF;
SIOREADDEVICEVERSION	SIOReadDeviceVersion;
SIOREADDEVICEPARTTYPE	SIOReadDevicePartType;
SIOWRITEPORTA			SIOWritePortA;
SIOWRITEPORTB			SIOWritePortB;
SIOWRITEPORTC			SIOWritePortC;
SIOWRITEPORTD			SIOWritePortD;
SIOINITDDRA				SIOInitDDRA;
SIOINITDDRB				SIOInitDDRB;
SIOINITDDRC				SIOInitDDRC;
SIOINITDDRD				SIOInitDDRD;
SIOREADPORTA			SIOReadPortA;
SIOREADPORTB			SIOReadPortB;
SIOREADPORTC			SIOReadPortC;
SIOREADPORTD			SIOReadPortD;
SIOREADEEPROM			SIOReadEEPROM;
SIOWRITEEEPROM			SIOWriteEEPROM;

#endif